jjb: disable some broken drivers from kernel builds
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
51fa2ab3 35 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
36}
37
38vergte() {
51fa2ab3 39 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
40}
41
42vergt() {
51fa2ab3 43 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
44}
45
339db64d 46
5a196804
MJ
47git_clone_modules_sources() {
48 mkdir -p "$MODULES_GIT_DIR"
49 git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
50}
51
52# Checkout a shallow kernel tree of the specified tag
53git_clone_linux_sources() {
54 mkdir -p "$LINUX_GIT_DIR"
55 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
56}
7e02032c 57
7e02032c 58
5a196804
MJ
59# Export the kernel sources from the git repo
60git_export_linux_sources() {
61 cd "$LINUX_GIT_DIR"
62 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
63}
64
65
66# Upload the tar archive to the object store
67upload_archive_obj() {
68 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
69 rm -f "$WORKSPACE/$obj_name"
70}
71
72
73extract_archive_obj() {
74 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
75 rm -f "$WORKSPACE/$obj_name"
76}
77
78
79tar_archive_obj() {
80 cd "$LINUX_OBJ_DIR"
81 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
82 cd -
83}
84
85# Find the most recent GCC version supported by the kernel sources
86select_compiler() {
87 local selected_cc
88
89 cd "$LINUX_SRCOBJ_DIR"
90
91 kversion=$(make -s kernelversion)
92
93 set +e
94
1d5a0a3c 95 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
96 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
97 selected_cc="$cc"
98 break
99 fi
100 done
101
102 set -e
103
104 if [ "x$selected_cc" = "x" ]; then
105 echo "Found no suitable compiler."
106 exit 1
107 fi
108
1d5a0a3c
MJ
109 # Force gcc-4.8 for kernels before 3.18
110 if { verlt "$kversion" "3.18"; }; then
23db2292 111 selected_cc=gcc-4.8
7e02032c
MJ
112 fi
113
425e4992
MJ
114 if [ "$selected_cc" != "gcc-4.8" ]; then
115 # Older kernel Makefiles do not expect the compiler to default to PIE
116 KAFLAGS="-fno-pie"
c45b04df 117 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
118 KCPPFLAGS="-fno-pie"
119 export KAFLAGS KCFLAGS KCPPFLAGS
120 fi
121
5a196804 122 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 123 export HOSTCC="${selected_cc}"
5a196804
MJ
124
125 cd -
126}
127
128
129build_linux_kernel() {
130 cd "$LINUX_SRCOBJ_DIR"
131
132 kversion=$(make -s kernelversion)
133
7e02032c 134 # Generate kernel configuration
a1ae361e 135 case "$ktag" in
7e02032c 136 Ubuntu*)
39961776 137 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 138 if vergte "${kversion}" "4.10"; then
39961776
MJ
139 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
140 exit 0
141 fi
142 fi
a46abb0a
MJ
143 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
144 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 145 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 146 ;;
c45b04df 147
7e02032c 148 *)
16844a6d
MJ
149 # Force 32bit build on i386, default is 64bit
150 if [ "$arch" = "i386" ]; then
5a196804
MJ
151 export ARCH="i386"
152 fi
153
154 # allyesconfig is mostly broken for kernels of the 2.6 series
155 if verlt "$kversion" "3.0"; then
156 vanilla_config="defconfig"
7a76a4d0
MJ
157 fi
158
5a196804 159 make "${vanilla_config}"
7e02032c
MJ
160 ;;
161 esac
162
5a196804
MJ
163 # silentoldconfig was renamed in 4.19
164 if vergte "$kversion" "4.19"; then
165 update_conf_target="syncconfig"
166 else
167 update_conf_target="silentoldconfig"
168 fi
169
170 # Fix 'defined(@array)' was removed from recent perl
171 if [ -f "kernel/timeconst.pl" ]; then
172 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
173 fi
174
175 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
23db2292 176 if [ "$CC" != "gcc-4.8" ]; then
5a196804
MJ
177 if [ -f "arch/x86/kvm/svm.c" ]; then
178 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
179 fi
180
181 if [ -f "arch/x86/kvm/vmx.c" ]; then
182 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
183 fi
184 fi
185
186 # Fix a typo in v2.6.36.x
187 if [ -f "arch/x86/kernel/entry_64.S" ]; then
188 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
189 fi
190
191 # Fix kernel < 3.0 with gcc >= 4.7
192 if verlt "$kversion" "3.0"; then
193 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
194 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
195 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
196 echo "header-y += linkage.h" >> include/linux/Kbuild
197 fi
198
7e02032c 199 # GCC 4.8
5a196804 200 sed -i "s/CONFIG_CC_STACKPROTECTOR_STRONG=y/# CONFIG_CC_STACKPROTECTOR_STRONG is not set/g" .config
7e02032c
MJ
201
202 # Don't try to sign modules
5a196804 203 sed -i "s/CONFIG_MODULE_SIG=y/# CONFIG_MODULE_SIG is not set/g" .config
7e02032c 204
9ef18fa2 205 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
5a196804
MJ
206 sed -i "s/CONFIG_STACK_VALIDATION=y/# CONFIG_STACK_VALIDATION is not set/g" .config
207
208 # Cause problems with inline assembly on i386
209 sed -i "s/CONFIG_DEBUG_SECTION_MISMATCH=y/# CONFIG_DEBUG_SECTION_MISMATCH is not set/g" .config
210
1d5a0a3c
MJ
211 # Don't build samples, they are broken on some kernel releases
212 sed -i "s/CONFIG_SAMPLES=y/# CONFIG_SAMPLES is not set/g" .config
c45b04df
MJ
213 sed -i "s/CONFIG_BUILD_DOCSRC=y/# CONFIG_BUILD_DOCSRC is not set/g" .config
214
215 # Disable kcov
216 sed -i "s/CONFIG_KCOV=y/# CONFIG_KCOV is not set/g" .config
217
218 # Broken on some RT kernels
219 sed -i "s/CONFIG_HYPERV=y/# CONFIG_HYPERV is not set/g" .config
1d5a0a3c 220
1e300ea9
MJ
221 # Broken drivers
222 sed -i "s/CONFIG_RAPIDIO_TSI721=y/# CONFIG_RAPIDIO_TSI721 is not set/g" .config
223 sed -i "s/CONFIG_SGI_XP=y/# CONFIG_SGI_XP is not set/g" .config
224 sed -i "s/CONFIG_MFD_WM8994=y/# CONFIG_MFD_WM8994 is not set/g" .config
225 sed -i "s/CONFIG_DRM_RADEON=y/# CONFIG_DRM_RADEON is not set/g" .config
226 sed -i "s/CONFIG_SND_SOC_WM5100=y/# CONFIG_SND_SOC_WM5100 is not set/g" .config
227
5a196804
MJ
228 # IGBVF won't build with recent gcc on 2.6.38.x
229 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
230 sed -i "s/CONFIG_IGBVF=y/# CONFIG_IGBVF is not set/g" .config
231 fi
9ef18fa2 232
51fa2ab3 233 # Set required options
c45b04df
MJ
234 sed -i 's/# CONFIG_KPROBES is not set/CONFIG_KPROBES=y/g' .config
235 sed -i 's/# CONFIG_FTRACE is not set/CONFIG_FTRACE=y/g' .config
236 sed -i 's/# CONFIG_BLK_DEV_IO_TRACE is not set/CONFIG_BLK_DEV_IO_TRACE=y/g' .config
237 sed -i 's/# CONFIG_KALLSYMS_ALL is not set/CONFIG_KALLSYMS_ALL=y/g' .config
7e02032c 238
7a76a4d0 239 # Debug
5a196804
MJ
240 #cat .config
241
242 make "$update_conf_target" CC="$CC"
243 make -j"$NPROC" CC="$CC"
244
c45b04df 245 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
246
247 # Save the kernel and modules
248 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
249 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install
250 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install
251 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
252 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
253 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
254}
255
256
257extract_distro_headers() {
258
259 # Enter linux source dir
260 cd "${LINUX_SRCOBJ_DIR}"
261
262
263 # For RT kernels, copy version file
264 if [ -s localversion-rt ]; then
265 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
266 fi
267
268 # Copy all Makefile related stuff
269 find . -path './include/*' -prune \
270 -o -path './scripts/*' -prune -o -type f \
271 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
272 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
273 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
274
275 # Copy base scripts and include dirs
276 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 277
5a196804
MJ
278 # Copy arch includes
279 (find arch -name include -type d -print0 | \
280 xargs -0 -n1 -i: find : -type f) | \
281 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
282
283 # Copy arch scripts
284 (find arch -name scripts -type d -print0 | \
285 xargs -0 -n1 -i: find : -type f) | \
286 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
287
288 # Cleanup scripts
289 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
290 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
291
292 # On powerpc this object is required to link modules
293 if [ "${karch}" = "powerpc" ]; then
294 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
295 fi
296
297 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
298 if [ "${karch}" = "arm64" ]; then
299 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
300 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
301 fi
302 fi
303
304 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
305 if [ -f tools/objtool/objtool ]; then
306 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
307 fi
308
309 if [ -f "arch/x86/kernel/macros.s" ]; then
310 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
311 fi
312
313 # Copy modules related stuff, if available
314 if [ -s Module.symvers ]; then
315 cp Module.symvers "${LINUX_HDROBJ_DIR}"
316 fi
317
318 if [ -s System.map ]; then
319 cp System.map "${LINUX_HDROBJ_DIR}"
320 fi
321
322 if [ -s Module.markers ]; then
323 cp Module.markers "${LINUX_HDROBJ_DIR}"
324 fi
325
326 # Copy config file
327 cp .config "${LINUX_HDROBJ_DIR}"
328
329 # Make sure the Makefile and version.h have a matching timestamp so that
330 # external modules can be built
331 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
332 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
333 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
334 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
335 else
336 echo "Missing version.h"
337 exit 1
338 fi
339 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
340
341 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
342 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
343
344 # Finally clean the object files from the full source tree
345 make clean
346
347 # And regen the modules support files
348 make modules_prepare CC="$CC"
51fa2ab3 349
d815b018
MJ
350 # On powerpc this object is required to link modules
351 if [ "${karch}" = "powerpc" ]; then
5a196804 352 make arch/powerpc/lib/crtsavres.o CC="$CC"
d815b018
MJ
353 fi
354
7a76a4d0 355 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 356 if [ "${karch}" = "arm64" ]; then
c236528e 357 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 358 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
359 fi
360 fi
361
7e02032c 362 # Version specific tasks
a1ae361e 363 case "$ktag" in
7e02032c
MJ
364 Ubuntu*)
365 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 366 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
367 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
368 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
369 ;;
370 esac
7e02032c
MJ
371}
372
373
339db64d
MJ
374build_modules() {
375
5a196804
MJ
376 local kdir="$1"
377 local outdir="$2"
378 local kversion
379
380 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 381
339db64d 382 # Enter lttng-modules source dir
5a196804 383 cd "${MODULES_GIT_DIR}"
339db64d
MJ
384
385 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
386 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
387 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
388 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
389
390 set +e
391
392 # Build modules
51fa2ab3 393 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 394 ret=$?
339db64d 395
5a196804
MJ
396 set -e
397
339db64d 398 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 399 if [ "$ret" -eq 0 ]; then
e9b44189 400 echo "This build should have failed."
339db64d
MJ
401 exit 1
402 fi
403
404 # We have to publish at least one file or the build will fail
5a196804 405 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 406
5a196804 407 KERNELDIR="${kdir}" make clean
7e02032c 408
339db64d
MJ
409 else # Regular build
410
411 # Build modules against full kernel sources
51fa2ab3 412 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
413
414 # Install modules to build dir
5a196804 415 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
416
417 # Clean build dir
5a196804 418 KERNELDIR="${kdir}" make clean
339db64d
MJ
419 fi
420}
421
422
423## MAIN ##
424
f3d8604b
MJ
425# Use all CPU cores
426NPROC=$(nproc)
427
5a196804
MJ
428MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
429LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 430
5a196804
MJ
431LINUX_OBJ_DIR="${WORKSPACE}/linux"
432LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
433LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
434LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 435
5a196804
MJ
436MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
437MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 438
5a196804
MJ
439LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
440
441OBJ_STORE_URL="s3://jenkins"
442
443cd "$WORKSPACE"
444
445# Create build directories
446mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
447
448git_clone_modules_sources
339db64d 449
7e02032c 450# Setup cross compile env if available
39961776 451if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
452
453 case "$cross_arch" in
454 "armhf")
455 karch="arm"
456 cross_compile="arm-linux-gnueabihf-"
e9b44189 457 vanilla_config="allyesconfig"
7e02032c
MJ
458 ubuntu_config="armhf-config.flavour.generic"
459 ;;
460
461 "arm64")
462 karch="arm64"
463 cross_compile="aarch64-linux-gnu-"
e9b44189 464 vanilla_config="allyesconfig"
7e02032c
MJ
465 ubuntu_config="arm64-config.flavour.generic"
466 ;;
467
468 "powerpc")
469 karch="powerpc"
470 cross_compile="powerpc-linux-gnu-"
e9b44189 471 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
472 ubuntu_config="powerpc-config.flavour.powerpc-smp"
473 ;;
474
475 "ppc64el")
476 karch="powerpc"
477 cross_compile="powerpc64le-linux-gnu-"
e9b44189 478 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
479 ubuntu_config="ppc64el-config.flavour.generic"
480 ;;
481
482 *)
51fa2ab3 483 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
484 exit 1
485 ;;
486 esac
339db64d 487
7e02032c
MJ
488 # Export variables used by Kbuild for cross compilation
489 export ARCH="${karch}"
490 export CROSS_COMPILE="${cross_compile}"
339db64d 491
7e02032c 492# Set arch specific values if we are not cross compiling
39961776 493elif [ "x${arch}" != "x" ]; then
e9b44189 494
7e02032c 495 case "$arch" in
16844a6d 496 "i386")
7e02032c 497 karch="x86"
e9b44189 498 vanilla_config="allyesconfig"
7e02032c
MJ
499 ubuntu_config="i386-config.flavour.generic"
500 ;;
501
16844a6d 502 "amd64")
7e02032c 503 karch="x86"
e9b44189 504 vanilla_config="allyesconfig"
7e02032c
MJ
505 ubuntu_config="amd64-config.flavour.generic"
506 ;;
507
508 "armhf")
509 karch="arm"
e9b44189 510 vanilla_config="allyesconfig"
7e02032c
MJ
511 ubuntu_config="armhf-config.flavour.generic"
512 ;;
513
514 "arm64")
515 karch="arm64"
e9b44189 516 vanilla_config="allyesconfig"
7e02032c
MJ
517 ubuntu_config="arm64-config.flavour.generic"
518 ;;
519
520 "powerpc")
521 karch="powerpc"
e9b44189 522 vanilla_config="allyesconfig"
7e02032c
MJ
523 ubuntu_config="powerpc-config.flavour.powerpc-smp"
524 ;;
525
526 "ppc64el")
527 karch="powerpc"
e9b44189 528 vanilla_config="allyesconfig"
7e02032c
MJ
529 ubuntu_config="ppc64el-config.flavour.generic"
530 ;;
531
532 *)
533 echo "Unsupported arch $arch"
534 exit 1
535 ;;
536 esac
537else
538 echo "Not arch or cross_arch specified"
539 exit 1
540fi
339db64d 541
339db64d 542
b214d997 543
5a196804
MJ
544# First get the kernel build from the object store, or build it, if it's
545# not available.
339db64d 546
5a196804
MJ
547echo "# Setup endpoint
548host_base = obj.internal.efficios.com
549host_bucket = obj.internal.efficios.com
550bucket_location = us-east-1
551use_https = True
7e02032c 552
5a196804
MJ
553# Setup access keys
554access_key = jenkins
555secret_key = echo123456
339db64d 556
5a196804
MJ
557# Enable S3 v4 signature APIs
558signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 559
c45b04df 560url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 561obj_name="linux.tar.bz2"
c45b04df 562obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
5a196804 563obj_url="$obj_url_prefix/$obj_name"
339db64d 564
5a196804
MJ
565set +e
566s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
567ret=$?
568set -e
339db64d 569
5a196804
MJ
570case "$ret" in
571 "0")
572 extract_archive_obj
573 ;;
a1ae361e 574
5a196804
MJ
575 "12")
576 echo "File not found"
339db64d 577
5a196804
MJ
578 # Build all the things and upload
579 # then finish the module build...
339db64d 580
5a196804
MJ
581 git_clone_linux_sources
582 git_export_linux_sources
339db64d 583
5a196804 584 select_compiler
a1ae361e 585
5a196804
MJ
586 ## PREPARE FULL LINUX SOURCE TREE
587 build_linux_kernel
d138fc44 588
5a196804
MJ
589 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
590 extract_distro_headers
339db64d 591
5a196804 592 tar_archive_obj
339db64d 593
5a196804 594 upload_archive_obj
339db64d 595
5a196804 596 ;;
339db64d 597
5a196804
MJ
598 *)
599 echo "Unknown error? Abort"
600 exit 1
601 ;;
602esac
339db64d 603
5a196804 604select_compiler
f3d8604b 605
7e02032c 606## BUILD modules
5a196804
MJ
607# Either we downloaded a pre-build kernel or we built it and uploaded
608# the archive for future builds.
609
610cd "$WORKSPACE"
f3d8604b 611
339db64d 612# Build modules against full kernel sources
5a196804 613build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 614
339db64d 615# Build modules against kernel headers
5a196804 616build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 617
5a196804
MJ
618# Make sure some modules were actually built
619tree "${MODULES_OUTPUT_KSRC_DIR}"
620if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
621 echo "No modules built!"
622 exit 1
623fi
624
5a196804
MJ
625tree "${MODULES_OUTPUT_KHDR_DIR}"
626if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
627 echo "No modules built!"
628 exit 1
629fi
b214d997 630
f3d8604b 631# EOF
This page took 0.053857 seconds and 4 git commands to generate.